Package: mdp
Title: Molecular Degree of Perturbation calculates scores for
        transcriptome data samples based on their perturbation from
        controls
Version: 1.33.0
Authors@R: c(person("Melissa", "Lever", email = "melissalever@gmail.com", role = c("aut")), person("Pedro", "Russo", email = "pedro.russo@usp.br", role = c("aut")),
            person("Helder", "Nakaya", email = "hnakaya@usp.br", role = c("aut", "cre")))
Description: The Molecular Degree of Perturbation webtool quantifies the heterogeneity of samples. It takes a data.frame of omic data that contains at least two classes (control and test) and assigns a score to all samples based on how perturbed they are compared to the controls. It is based on the Molecular Distance to Health (Pankla et al. 2009), and expands on this algorithm by adding the options to calculate the z-score using the modified z-score (using median absolute deviation), change the z-score zeroing threshold, and look at genes that are most perturbed in the test versus control classes. 
URL: https://mdp.sysbio.tools/
biocViews: BiomedicalInformatics, QualityControl, Transcriptomics,
        SystemsBiology, Microarray, QualityControl
Depends: R (>= 4.0)
License: GPL-3
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.1
Imports: ggplot2, gridExtra, grid, stats, utils
Suggests: testthat, knitr, rmarkdown, fgsea, BiocManager
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/mdp
git_branch: devel
git_last_commit: 0fae065
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:36:29 UTC; biocbuild
Author: Melissa Lever [aut],
  Pedro Russo [aut],
  Helder Nakaya [aut, cre]
Maintainer: Helder Nakaya <hnakaya@usp.br>

Please refer to the online documentation at https://mdpdocs.readthedocs.io
The legacy documentation is still available at http://mdp-toolkit.sourceforge.net
The source code is available at https://github.com/mdp-toolkit/mdp-toolkit

## mdp - A command-line based markdown presentation tool.

![image](https://cloud.githubusercontent.com/assets/2237222/5810237/797c494c-a043-11e4-9dbd-959cab4055fa.gif)

---

***How to get started:***

mdp needs the ncursesw headers to compile.
So make sure you have them installed:

- on Cygwin you need `libncursesw10` and `libncurses-devel`
- on Raspbian (Raspberry Pi) you need `libncurses5-dev` and `libncursesw5-dev`

Now download and install mdp:

    $ git clone https://github.com/visit1985/mdp.git
    $ cd mdp
    $ make
    $ make install
    $ mdp sample.md

- On Arch, you can use the existing [AUR package](https://aur.archlinux.org/packages/mdp-git/).
- On Debian, you can use the existing [DEB package](https://tracker.debian.org/pkg/mdp-src), or run `apt-get install mdp`.
- On FreeBSD, you can use the port [misc/mdp](http://www.freshports.org/misc/mdp).
- On OS-X, use the existing [Homebrew Formula](http://brewformulas.org/Mdp) by running `brew install mdp`.
- On Slackware, grab the SlackBuild here: (http://slackbuilds.org/apps/mdp/), or run `sbopkg -i mdp`.
- On Ubuntu, you can use the existing [DEB package](https://launchpad.net/ubuntu/+source/mdp-src), or run `apt-get install mdp`.

Most terminals support 256 colors only if the TERM variable is
set correctly. To enjoy mdp's color fading feature:

    $ export TERM=xterm-256color

---

***How to use it:***

Horizontal rulers are used as slide separator.

Supports basic markdown formating:

- line wide markup
    - headlines
    - code
    - quotes
    - unordered list

- in-line markup
    - bold text
    - underlined text
    - code

Supports headers prefixed by @ symbol.

- first two header lines are displayed as title and author
    in top and bottom bar

Review sample.md for more details.

---

***Controls:***

- h, j, k, l, Arrow keys,
    Space, Enter, Backspace,
    Page Up, Page Down - next/previous slide
- Home, g - go to first slide
- End, G - go to last slide
- 1-9 - go to slide n
- r - reload input file
- q - exit


---

***How to debug it:***

To make a debug version of `mdp`, just type:

    $ make DEBUG=1

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## -----------------------------------------------------------------------------
library(mdp)
data(example_data) # expression data has gene names in the rows
data(example_pheno) # pheno data needs a Sample and Class column
mdp.results <- mdp(data=example_data, pdata=example_pheno, control_lab = "baseline")

## -----------------------------------------------------------------------------
sample_scores_list <- mdp.results$sample_scores
# select sample scores calculated using the perturbed genes
sample_scores <- sample_scores_list[["perturbedgenes"]]
head(sample_scores)
sample_plot(sample_scores,control_lab = "baseline", title="perturbed")

## -----------------------------------------------------------------------------
zscore <- mdp.results$zscore

## -----------------------------------------------------------------------------
gene_scores <- mdp.results$gene_scores
gene_freq <- mdp.results$gene_freq
head(gene_scores)

## -----------------------------------------------------------------------------
perturbed_genes <- mdp.results$perturbed_genes

## ----results='hide',fig.show = 'hide'-----------------------------------------
file_address <- system.file("extdata", "ReactomePathways.gmt", package = "mdp")
pathways <- fgsea::gmtPathways(file_address)
mdp.results <- mdp(data=example_data, pdata=example_pheno, control_lab = "baseline",pathways=pathways)

## -----------------------------------------------------------------------------
head(mdp.results$pathways)
sample_scores <- mdp.results$sample_scores[["Interferon alpha/beta signaling"]]
sample_plot(sample_scores,control_lab = "baseline", title="Interferon a/b")


## ----results='hide',fig.show = 'hide'-----------------------------------------
mdp.results <- mdp(data=example_data, pdata=example_pheno, control_lab = "baseline", measure = "mean")

## -----------------------------------------------------------------------------
control_samples <- example_pheno[example_pheno$Class == "baseline","Sample"] 
zscore <- compute_zscore(data = example_data,control_samples = control_samples,measure = "mean",std = 2)

#' Molecular Degree of Perturbation
#'
#' Based on the Molecular Distance to Health, this function calculates scores
#' to each sample based on their perturbation from healthy
#'
#' @export
#' @param data \code{data frame} of gene expression data with the gene symbols
#' in the row names
#' @param pdata \code{data frame} of phenodata with a column headed Class and the
#' other headed Sample.
#' @param control_lab character \code{vector} specifying the control class
#' @param print set as default to TRUE for pdfs of the sample scores
#' to be saved
#' @param directory (optional) character string of output directory
#' @param pathways (optional) \code{list} whose names are pathways and elements are
#' genes in the pathway. see details section for more information
#' @param measure 'mean' as default, can change to 'median'.
#' \code{mean} will select for z-score and \code{median} will select for modified
#' z-score. (see details)
#' @param std \code{numeric} set as default to 2, this governs the thresholding of
#' expression data. z-scored expression values with absolute value less than 'std'
#' will be set to 0.
#' @param fraction_genes \code{numeric} fraction of genes that will contribute to the top perturbed genes. Set as default to 0.25
#' @param save_tables Set as default to TRUE. Tables of zscore and gene and
#' sample scores will be saved.
#' @param file_name (optional) character string that will be added to the saved file names
#' @return A list: zscore, gene_scores, gene_freq, sample_scores, perturbed_genes
#' \itemize{
#' \item Z-score - z-score is calculated using the control samples to compute
#' the average and the standard deviation. The absolute value of this
#' matrix is taken and values less than the std are set to zero.
#' This z-score data frame is used to compute the gene and sample scores.
#' \item Gene scores - mean z-score value for each gene in each class
#' \item Gene frequency - frequency with which a gene has a non zero z-score
#' value in each class
#' \item Sample scores - list containing sample scores for different genesets.
#' Sample scores are the sum of the z-scored gene values for each sample,
#' averaged for the number of genes in that geneset.
#' \item Perturbed genes - vector of the top fraction of genes that have
#' higher gene scores in the test classes compared to the control.
#' \item Pathways - if genesets are provided, they are ranked according to the
#' signal-to-noise #' ratio of test sample scores versus control sample scores
#' calculated using that geneset.
#'}
#' @examples
#' # basic run
#' mdp(example_data,example_pheno,'baseline')
#' # run with pathways
#' pathway_file <- system.file('extdata', 'ReactomePathways.gmt',
#' package = 'mdp')
#' mypathway <- fgsea::gmtPathways(pathway_file) # load a gmt file
#' mdp(data=example_data,pdata=example_pheno,control_lab='baseline',
#' pathways=mypathway)
#' @importFrom utils write.table
#' @importFrom stats mad median sd
#' @section Loading pathways:
#' a \code{list} of pathways can be loaded from a .gmt file using the
#' \code{fgsea} function using \code{fgsea::gmtPathways('gmt.file.location')}
#' @section Selecting mean or median:
#' if \code{median} is selected, the z-score will be calculated using the
#' median, and the standard deviation will be estimated using the median
#'  absolute deviation, utilising the \code{mad} function.
mdp <- function(data, pdata, control_lab, directory = "", pathways,
                print = TRUE,
                measure = c("mean","median"), std = 2, fraction_genes = 0.25,
                save_tables = TRUE, file_name = "") {

    # ---------- create directory ---------------------------------#######

    if (directory != "") {
        path = directory
        if (dir.exists(directory) == FALSE) {
            dir.create(directory)
        }
    } else {
        path = "."
    }


    # --------------------- ORGANISE DATA -------------------------#######

    if (missing(pdata)) {
        stop("Please include phenodata")
    }
    if (missing(data)) {
        stop("Please include expression data")
    }
    if (missing(control_lab)) {
        stop("Please include control label")
    }

    if (!("Sample" %in% names(pdata) && "Class" %in% names(pdata))) {
        stop("Please label phenodata columns as 'Sample' and 'Class'")
    } else if (sum(pdata$Sample %in% names(data)) == 0) {
        stop("Please provide phenodata sample names that match expression data columns")
    } else if (sum(control_lab %in% pdata$Class) == 0) {
        stop("Please provide a control label that matches a class in the phenodata")
    } else if (sum(pdata$Class %in% control_lab) < 2) {
        stop("Please provide at least two control samples (around 10 is an ideal minimum)")
    }

    if (!all(apply(data[, ], 2, is.numeric))) {
        stop("Please provide numeric values in expression data columns")
    }

    if (!is.numeric(fraction_genes)){
        stop("Select a numeric gene fraction of value less than 1")
    } else if (fraction_genes > 1) {
        stop("Select a gene fraction of less than 1")
    }


    if (!is.numeric(std)){
      stop("Select a numeric standard deviation threshold")
    }


    if (!missing(pathways)) {
        if (!is.list(pathways)) {
            stop("Please provide pathways in a list format (see help for more details")
        }
    }

    # New feature to detect problem in colnames expression data
    if (sum(grepl("^[0-9]", colnames(data), perl = TRUE)) > 0) {
	stop("Please provide colnames expression label starting with letter (a-A to z-Z).")
    }


    measure <- match.arg(measure)

    # Only keep the samples that have both pdata and data
    pdata <- pdata[as.character(pdata$Sample) %in% colnames(data), ]
    rownames(pdata) <- pdata$Sample
    # Expression data has only samples that are in pdata
    data <- data[, as.character(pdata$Sample)]

    control_samples <- as.character(pdata$Sample[pdata$Class == control_lab])
    test_samples <- as.character(pdata$Sample[pdata$Class != control_lab])

    message("Calculating Z score")
    zscore <- compute_zscore(data, control_samples, measure, std)

    message("Calculating gene scores")

    # find gene scores and gene frequency for each class

    gmdp_results <- compute_gene_score(zscore,
                                        pdata,
                                        control_lab,
                                        "gene_score")

    gmdp_freq_results <- compute_gene_score(zscore,
                                            pdata,
                                            control_lab,
                                            "gene_freq")

    # find perturbed genes
    perturbed_genes <- compute_perturbed_genes(gmdp_results,
                                                control_lab,
                                                fraction_genes)

    message("Calculating sample scores")
    # calculate sample scores
    sample_results <- compute_sample_scores(zscore, perturbed_genes,
                                            control_samples, test_samples,
                                            pathways, pdata)

    message("Suggesting outliers samples")
    sample_results <- check_outlier_samples(x = compute_zscore_classes(x = sample_results), control = control_lab)

    if (print == TRUE) {

        message("printing")

        sample_plot(sample_results[["allgenes"]],
                    filename = paste0(file_name, "allgenes"),
                    directory = path,
                    print = TRUE,
                    display = TRUE,
                    title = "All genes",
                    control_lab = control_lab)

        sample_plot(sample_results[["perturbedgenes"]],
                    filename = paste0(file_name, "perturbed"),
                    directory = path,
                    print = TRUE,
                    display = FALSE,
                    title = paste0("Top (", fraction_genes * 100, ") perturbed genes"),
                    control_lab = control_lab)

        if (!missing(pathways)) {
            pathway_results <- pathway_summary(sample_results,
                                                path, file_name,
                                                control_samples,
                                                control_lab)

        }

    }

    if (save_tables == TRUE) {

        write.table(x = zscore,
                    file = file.path(path, paste0(file_name, "zscore.tsv")),
                    row.names = FALSE, sep = "\t")
        write.table(x = gmdp_results,
                    file = file.path(path, paste0(file_name, "gene_scores.tsv")),
                    row.names = FALSE, sep = "\t")
        write.table(x = sample_results,
                    file = file.path(path, paste0(file_name, "sample_scores.tsv")),
                    row.names = FALSE, sep = "\t")

    }

    # ---------------- OUTPUT ---------------- ####
    if (missing(pathways)) {

        output <- list(zscore,
                        gmdp_results,
                        gmdp_freq_results,
                        sample_results,
                        perturbed_genes)

        names(output) <- c("zscore",
                            "gene_scores",
                            "gene_freq",
                            "sample_scores",
                            "perturbed_genes")

    } else {
        output <- list(zscore,
                        gmdp_results,
                        gmdp_freq_results,
                        sample_results,
                        perturbed_genes,
                        pathway_results)

        names(output) <- c("zscore",
                            "gene_scores",
                            "gene_freq",
                            "sample_scores",
                            "perturbed_genes",
                            "pathways")

    }



    return(output)
}


#' Computes the thresholded Z score
#' Plots the Z score using control samples to compute the average and standard
#' deviation
#' @export
#' @param data Gene expression data with gene symbols in rows, sample names
#' in columns
#' @param control_samples Character vector specifying the control sample names
#' @param measure Either 'mean' or 'median'. 'mean' uses mean and standard
#' deviation. 'median' uses the median and the median absolute deviation to
#' estimate the standard devation (modified z-score).
#' @param std Set as default to 2. This controls the standard deviation threshold
#' for the Z-score calculation. #' Normalised expression values less than 'std'
#' will be set to 0.
#' @examples
#' control_samples <- example_pheno$Sample[example_pheno$Class == 'baseline']
#' compute_zscore(example_data, control_samples,'median',2)
#' @return zscore data frame
compute_zscore <- function(data, control_samples, measure = c("mean","median"), std = 2) {

    measure <- match.arg(measure)


    if (measure == "mean") {
        stats = data.frame(mean = rowMeans(data[, control_samples]),
                            std = apply(data[, control_samples], 1, sd))

    } else if (measure == "median") {
        # use the median absolute deviation to estimate the standard deviation

        stats = data.frame(mean = apply(data[, control_samples], 1, median),
                            std = apply(data[, control_samples], 1, mad))

    } else {
        stop("Please specify either 'mean' or 'median' as a measure input")
    }

    # compute Z score
    zscore <- (data - stats[, 1])/stats[, 2]
    rownames(zscore) <- rownames(data)
    zscore <- zscore[!is.infinite(rowSums(zscore)), ]
    zscore <- zscore[!is.na(rowSums(zscore)), ]
    zscore <- abs(zscore)
    zscore[zscore < std] <- 0
    zscore <- data.frame(Symbol = rownames(zscore), zscore)

    return(zscore)
}


#' Computes the thresholded t score
#' Plots the t score using control samples to compute the average and standard
#' deviation divided by N samples
#' @export
#' @param data Gene expression data with gene symbols in rows, sample names
#' in columns
#' @param control_samples Character vector specifying the control sample names
#' @param measure Either 'mean' or 'median'. 'mean' uses mean and standard
#' deviation. 'median' uses the median and the median absolute deviation to
#' estimate the standard devation (modified t-score).
#' @param std Set as default to 2. This controls the standard deviation threshold
#' for the Z-score calculation. #' Normalised expression values less than 'std'
#' will be set to 0.
#' @examples
#' control_samples <- example_pheno$Sample[example_pheno$Class == 'baseline']
#' compute_zscore(example_data, control_samples,'median',2)
#' @return zscore data frame
#' TODO testin tscore function to penalize small samples - Andre Nicolau
compute_tscore <- function(data, control_samples, measure = c("mean","median"), std = 2) {

  measure <- match.arg(measure)


  if (measure == "mean") {
    stats = data.frame(mean = rowMeans(data[, control_samples]),
                       std = apply(data[, control_samples], 1, sd))

  } else if (measure == "median") {
    # use the median absolute deviation to estimate the standard deviation

    stats = data.frame(mean = apply(data[, control_samples], 1, median),
                       std = apply(data[, control_samples], 1, mad))

  } else {
    stop("Please specify either 'mean' or 'median' as a measure input")
  }

  # compute Z score
  zscore <- (data - stats[, 1])/(stats[, 2])
  rownames(zscore) <- rownames(data)
  zscore <- zscore[!is.infinite(rowSums(zscore)), ]
  zscore <- zscore[!is.na(rowSums(zscore)), ]
  zscore <- abs(zscore)
  zscore[zscore < std] <- 0
  zscore <- data.frame(Symbol = rownames(zscore), zscore)

  return(zscore)
}


#' Compute gene score
#' Computes gene scores for each gene within each class and perturbation freq
#' @param zscore zscore data frame
#' @param pdata phenotypic data with Class and Sample columns
#' @param control_lab character specifying control class
#' @param score_type set to 'gene_score' or 'gene_freq' to compute gene scores
#' or frequencies
#' @return data frame of gene scores or gene frequencies
compute_gene_score <- function(zscore, pdata, control_lab, score_type = c("gene_score","gene_freq")) {

    score_type <- match.arg(score_type)

    all_groups <- unique(pdata$Class)  # find all groups
    # find all_groups, without the control label
    groups_no_control <- all_groups[-grep(control_lab, all_groups)]

    gene_results <- zscore$Symbol  # table to save the gene scores

    for (group in all_groups) {
        if (score_type == "gene_score") {
            # find average expression of gene in each class
            gene_average <- rowMeans(zscore[, as.character(pdata$Sample[pdata$Class == group])])

        } else if (score_type == "gene_freq") {

            # find frequency that gene is perturbed in each class
            gene_average <- rowMeans(zscore[, as.character(pdata$Sample[pdata$Class == group])] > 0)
        }

        gene_results <- data.frame(gene_results, gene_average)

    }

    names(gene_results) <- c("Symbol", as.character(all_groups))

    return(gene_results)
}



#' Compute perturbed genes
#' Find the top fraction of genes that are more perturbed
#' in test versus controls
#' @param gmdp_results results table of gene scores
#' @param control_lab label specificying control class
#' @param fraction_genes fraction of top perturbed genes that
#' will make the set of perturbed genes
#' @return vector of perturbed genes
compute_perturbed_genes <- function(gmdp_results,
                                    control_lab, fraction_genes) {

    control_idx <- grep(control_lab, names(gmdp_results))

    num_test_groups <- dim(gmdp_results)[2] - 2

    # score is proportional to: av. test group gene score - control
    score <- rowSums(gmdp_results[, -c(1, control_idx), drop = FALSE]) -
                    (num_test_groups * gmdp_results[, control_idx])

    # order gene scores according to the difference in test vs control scores
    gmdp_results <- gmdp_results[order(-score), ]

    # perturbed genes are top fraction of ordered genes
    perturbed_genes <- gmdp_results$Symbol[1:round(fraction_genes *
                                            dim(gmdp_results)[1])]


    return(perturbed_genes)
}





#' Compute sample scores for each pathway
#' @param zscore zscore data frame
#' @param perturbed_genes list of pertured genes
#' @param control_samples vector of control sample names
#' @param test_samples vector of test sample names
#' @param pathways list of pathways
#' @param pdata phenotypic data with Sample and Class columns
#' @return data frame of sample scores
compute_sample_scores <- function(zscore, perturbed_genes, control_samples,
                                    test_samples, pathways, pdata) {

    genesets <- list()  # list of all gene sets
    genesets[[1]] <- zscore$Symbol
    genesets[[2]] <- perturbed_genes
    names(genesets)[1:2] <- c("allgenes", "perturbedgenes")

    if (!missing(pathways)) {
        genesets <- c(genesets, pathways)
    }

    # calculate sample scores for all genesets
    sample_results <- lapply(seq_along(genesets), function(idx) {
        sample_scores <- colMeans(zscore[zscore$Symbol %in% genesets[[idx]], 2:ncol(zscore)])
        data.frame(Sample = names(sample_scores),
                   Score = sample_scores,
                   Class = pdata[names(sample_scores), "Class"])
    })

    names(sample_results) <- names(genesets)

    return(sample_results)
}


#' Plot sample scores
#' Plots the sample scores data.frame for a given geneset.
#' Data frame must have Score, Sample and Class columns
#' @export
#' @param sample_data \code{data frame} of sample score information for a geneset.
#' Must have columns 'Sample', 'Score' and 'Class'
#' @param filename (optional) character string that will be added to the saved pdf filename
#' @param directory (optional) character string of directory to save file
#' @param title (optional) character string of title name for graph
#' @param print (default TRUE) Save as a pdf file
#' @param display (default TRUE) Display plot
#' @param control_lab (optional) character string Specifying control_lab will set the control
#' class as light blue as a default
#' @importFrom gridExtra grid.arrange
#' @examples
#' sample_plot(sample_data = sample_data, control_lab = 'baseline')
#' @return generates a plot of the sample scores
sample_plot <- function(sample_data, filename = "",
                        directory = "", title = "", print = TRUE,
                        display = TRUE, control_lab) {


    if (!("Sample" %in% names(sample_data)) |
        !("Class" %in% names(sample_data)) |
        !("Score" %in% names(sample_data))){
        stop("Sample data must be data frame with colnames 'Class' 'Sample' 'Score'")
    }


    if (missing(control_lab)) {
        stop("Please include control label")
    }



    if (directory != "") {
        path = directory
        if (dir.exists(directory) == FALSE) {
            dir.create(directory)
        }

    } else {
        path = "."
    }

    if (length(unique(sample_data$Geneset)) > 1) {
        stop("Please subset sample scores for one geneset only")
    }



    # make color for each class, with control class as light blue
    groups <- unique(sample_data$Class)
    palette <- c("#86cce0", "#4da566", "#d67048", "#b59519", "#FDBF6F", "#FF7F00", "#CAB2D6", "#6A3D9A")

    if (length(groups) > length(palette)) {
        palette <- rep(palette, ceiling(length(groups)/length(palette)))
    }
    groups_coloured <- palette[1:length(groups)]

    if (!missing(control_lab)) {
        if (!(control_lab %in% sample_data$Class)) {

            stop("Please provide control label that features in the sample data")
        } else {

            groups_reordered <- c(control_lab,
                                    as.character(groups[-grep(control_lab,
                                                        groups)]))

            names(groups_coloured) <- groups_reordered
        }
    }


    sample_data <- sample_data[order(sample_data$Score), ]
    sample_data$Sample <- factor(sample_data$Sample,
                                levels = sample_data$Sample[order(sample_data$Score)])

    # Plot scores as bar graphs
    plot1 <- ggplot2::ggplot(data = sample_data,
                            ggplot2::aes_string(y = "Score",
                                                x = "Sample",
                                                fill = "Class")) +
                ggplot2::geom_bar(stat = "identity",
                                    width = 0.8,
                                    alpha = 0.7) +
                ggplot2::labs(title = title,
                                    x = "Samples",
                                    y = "Sample score") +
                ggplot2::theme(axis.line = ggplot2::element_line(size = 0.5, linetype = "solid"),
                                panel.grid.major =
                                ggplot2::element_line(colour = "black",
                                                    linetype = "blank"),
                                panel.grid.minor =
                                        ggplot2::element_line(linetype = "blank"),
                                axis.title = ggplot2::element_text(size = 18),
                                axis.text = ggplot2::element_text(size = 12),
                                axis.text.x = ggplot2::element_text(size = 12,
                                                                    angle = 60,
                                                                    hjust = 1),
                                plot.title = ggplot2::element_text(size = 18),
                                panel.background =
                                        ggplot2::element_rect(fill = "grey100"),
                                legend.text = ggplot2::element_text(size = 12),
                                legend.title = ggplot2::element_text(size = 14),
                                legend.key.size = ggplot2::unit(0.9, "line"),
                                legend.position = c(0.23, 0.85),
                                legend.direction = "vertical") +
                ggplot2::theme(panel.background =
                                ggplot2::element_rect(fill = NA,
                                                    linetype = "solid")) +
                ggplot2::scale_fill_manual(values = groups_coloured)




    # find means of sample scores
    class_means <- vector()
    for (j in unique(sample_data$Class)) {
        class_means = c(class_means,
                        mean(sample_data[sample_data$Class == j,
                                        "Score"]))
    }
    names(class_means) <- unique(sample_data$Class)
    class_means <- class_means[order(class_means)]


    ## Boxplot of scores
    plot2 <- ggplot2::ggplot(data = sample_data,
                            ggplot2::aes_string(y = "Score",
                                                x = "Class",
                                                fill = "Class")) +
            ggplot2::geom_boxplot(outlier.shape = NA) +
            ggplot2::stat_summary(fun = mean,
                                    geom = "point",
                                    shape = 23,
                                    size = 6) +
            ggplot2::labs(title = title,
                            x = "Class",
                            y = "Sample score") +
            ggplot2::theme(legend.position = "null") +
            ggplot2::scale_x_discrete(limits = names(class_means)) +
            ggplot2::geom_jitter(shape = 16,
                                position = ggplot2::position_jitter(0.2),
                                size = 2, color = "grey10", alpha = 0.7) +
        ggplot2::theme(axis.line = ggplot2::element_line(size = 0.5,
                                                        linetype = "solid"),
                        axis.title =
                                    ggplot2::element_text(size = 18),
                        panel.grid.major =
                                    ggplot2::element_line(linetype = "blank"),
                        panel.grid.minor =
                                    ggplot2::element_line(linetype = "blank"),
                        plot.title = ggplot2::element_text(size = 18),
                        panel.background =
                                    ggplot2::element_rect(fill = "white"),
                        axis.text.x =
                                    ggplot2::element_text(angle = 60, hjust = 1),
                        legend.text =
                                    ggplot2::element_text(size = 12),
                        axis.text = ggplot2::element_text(size = 12)) +
        ggplot2::scale_fill_manual(values = groups_coloured)


    if (print == TRUE) {
        sample_name <- paste(filename, "samples.pdf", sep = "")
        grDevices::pdf(file.path(path, sample_name))
        gridExtra::grid.arrange(plot1, plot2, ncol = 2)
        grDevices::dev.off()
    }

    if (display == TRUE) {
	gridExtra::grid.arrange(plot1, plot2, ncol = 2)
    }

}





# -------- Multiple plot function (R cookbook) ---- ####
# ggplot objects can be passed in ..., or to plotlist
# (as a list of ggplot2::ggplot
# objects) - cols: Number of columns in layout - layout:
# A matrix specifying the layout.
# If present, 'cols' is ignored.  If the layout is
# something like matrix(c(1,2,3,3), nrow=2, byrow=TRUE), then
# plot 1 will go in the upper left,
# 2 will go in the upper right, and 3 will go all
# the way across the bottom.
#http://www.cookbook-r.com/Graphs/Multiple_graphs_on_one_page_(ggplot2)/
multiplot <- function(..., plotlist = NULL,
                    file, cols = 1, layout = NULL) {

    # Make a list from the ... arguments and plotlist

    plots <- c(list(...), plotlist)

    numPlots = length(plots)

    # If layout is NULL, then use 'cols' to determine layout
    if (is.null(layout)) {
        # Make the panel ncol: Number of columns of plots nrow:
        # Number of rows needed, calculated from # of cols
        layout <- matrix(seq(1, cols * ceiling(numPlots/cols)),
                        ncol = cols, nrow = ceiling(numPlots/cols))
    }

    if (numPlots == 1) {
        print(plots[[1]])

    } else {
        # Set up the page
        grid::grid.newpage()
        grid::pushViewport(grid::viewport(layout =
                                    grid::grid.layout(nrow(layout), ncol(layout))))

        # Make each plot, in the correct location

        for (i in 1:numPlots) {

            # Get the i,j matrix positions of the regions
            # that contain this subplot
            matchidx <- as.data.frame(which(layout == i, arr.ind = TRUE))

            print(plots[[i]],
                  vp = grid::viewport(layout.pos.row = matchidx$row,
                                    layout.pos.col = matchidx$col))
        }
    }
}
# Replaced with gridExtra::grid.arrange

#' print pathways
#' generates a summary plot for pathways and sample score plot of best gene set
#' @param sample_results list of sample scores for each geneset
#' @param path directory to save images
#' @param file_name name of saved imaged
#' @param control_samples list of control sample names
#' @param control_lab label that specifies control class
#' @return data frame of signal to noise ratio of control vc test sample scores
#' for each pathway
pathway_summary <- function(sample_results, path, file_name,
                            control_samples, control_lab) {
    signal_noise <- vector()

    signal_noise <- vapply(seq_along(sample_results), function(idx) {
        sample_sub <- sample_results[[idx]]
        control_scores <- sample_sub[sample_sub$Sample %in% control_samples,
                                     "Score"]
        test_scores <- sample_sub[!(sample_sub$Sample %in% control_samples),
                                  "Score"]
        signal_noise[idx] <- (mean(test_scores) - mean(control_scores))/
            (sd(test_scores) + sd(control_scores))
    }, numeric(1)
    )

    pathway_scores <- data.frame(Geneset = names(sample_results),
                                Sig2noise = signal_noise)

    pathway_scores <- pathway_scores[order(-pathway_scores$Sig2noise), ]

    # find best pathway
    top_pathway <- pathway_scores[1:3, "Geneset"]
    top_pathway <- top_pathway[top_pathway != "allgenes" &
                                top_pathway != "perturbedgenes"]
    top_pathway <- top_pathway[1]


    sample_plot(sample_results[[top_pathway]],
                filename = paste0(file_name, "bestPathway"),
                directory = path, title = top_pathway,
                print = TRUE,
                display = TRUE, control_lab)

    return(pathway_scores)

}

#' Computes the Z score of each class
compute_zscore_classes <- function(x, colScore = 2, colClass = 3) {
  for(name in names(x)) {
    x_temp <- x[[name]]
    mdp_score_zscore <- NULL
    for(class in unique(sort(x_temp[, colClass]))) {
      mdp_score_temp <- x_temp[x_temp[, colClass] == class,]
      mdp_score_temp$zscore_class <- scale(mdp_score_temp[, colScore])
      mdp_score_zscore <- rbind(mdp_score_zscore, mdp_score_temp)
      x[[name]] <- mdp_score_zscore
    }
  }
  return(x)
}

#' Check samples are potential outliers
#' Calculate the zscore inside specific class to identify pontential outliers
#' @param x
check_outlier_samples <- function(x, colScore = 2, colClass = 3, control = "healthy", threshold = 2) {
  for(name in names(x)) {
    x_temp <- x[[name]]
    if(!control %in% unique(sort(x_temp[, colClass]))) {
      stop("Control variable: ", control, " didn't identified like as class!")
    }
    x_temp$outlier <- ifelse(x_temp[, colClass] == control & x_temp$zscore_class > threshold, 1, ifelse(x_temp[, colClass] != control & x_temp$zscore_class < -threshold, 1, 0))
    x[[name]] <- x_temp
  }
  return(x)
}

context("correct input files for mdp function")

data(example_data)
data(example_pheno)


test_that("errors are returned when there are missing inputs",{
    
    expect_error(mdp(),
                 "Please*")
    expect_error(mdp(data=example_data),
                 "Please*")
    expect_error(mdp(pdata=example_pheno),
                 "Please*")
    expect_error(mdp(data=example_data,pdata=example_pheno),
                 "Please*")  
    
})



test_that("errors are returned when pheno data is not in correct format",{
    
    pheno_wrong <- example_pheno
    names(pheno_wrong) <- c("Label1","Label2")
    
    expect_error(mdp(data=example_data,pdata=pheno_wrong,control_lab="baseline"),
                 "*phenodata*")  
    
    expect_error(mdp(data=example_data,pdata=example_pheno,control_lab="healthy"),
                 "*control*")  
    expect_error(mdp(data=example_data,pdata=example_pheno[20:40,],control_lab="baseline"),
                 "*two control*")  
    
})


test_that("errors are returned when data and input parameters are not numeric",{
    
    data_wrong <- example_data
    data_wrong[,1] <- as.character(example_data[,1])
    
    expect_error(mdp(data=data_wrong,pdata=example_pheno,control_lab="baseline"),
                 "*numeric*")  
    
    expect_error(mdp(data=example_data,pdata=example_pheno,control_lab="baseline",fraction_genes = "n"),
                 "*numeric*")  
    
    expect_error(mdp(data=example_data,pdata=example_pheno,control_lab="baseline",std = "n"),
                 "*numeric*")  
    
    
})

test_that("errors are returned when pathways are not a list",{
    
    expect_error(mdp(data=example_data,pdata=example_pheno,control_lab="baseline",pathways="pathways"),
                 "*list*")  

})

context("correct output for z-score function")


data(example_data)
data(example_pheno)

control_samples <- example_pheno[example_pheno$Class == "baseline","Sample"] 



test_that("same z score values are returned when data is made negative",{

example_data_neg <- example_data*(-1)

zscore_pos <- compute_zscore(data = example_data,
                             control_samples = control_samples,
                             measure = "mean",
                             std = 2)

zscore_neg <- compute_zscore(data = example_data_neg,
                             control_samples = control_samples,
                             measure = "mean"
                             ,std = 2)

expect_equal(zscore_pos,zscore_neg)

zscore_pos <- compute_zscore(data = example_data,
                             control_samples = control_samples,
                             measure = "median",
                             std = 2)

zscore_neg <- compute_zscore(data = example_data_neg,
                             control_samples = control_samples,
                             measure = "median",
                             std = 2)

expect_equal(zscore_pos,zscore_neg)


})

context("correct input for sample_plot")


data(example_data)
data(example_pheno)

mdp.results <- mdp(data=example_data, pdata=example_pheno, control_lab = "baseline")
sample_scores_list <- mdp.results$sample_scores
sample_data <- sample_scores_list[["perturbedgenes"]]


test_that("function does not run if sample data is missing correct classes",{
    
    names(sample_data) <- c("wrong","Score","Class")
    expect_error(sample_plot(sample_data,control_lab = "baseline"),
                 "Sample data")
    
    names(sample_data) <- c("Sample","wrong","Class")
    expect_error(sample_plot(sample_data,control_lab = "baseline"),
                 "Sample data")
    
    names(sample_data) <- c("Sample","Score","wrong")
    expect_error(sample_plot(sample_data,control_lab = "baseline")
                 ,"Sample data")
})

context("correct output for mdp function")



data(example_data)
data(example_pheno)

file_address <- system.file("extdata", "ReactomePathways.gmt", package = "mdp")
pathways <- fgsea::gmtPathways(file_address)

test_that("list of correct size is returned",{
    
    output <- mdp(data=example_data,pdata=example_pheno,control_lab="baseline")
    expect_that(length(output),equals(5))  
    
    output <- mdp(data=example_data,pdata=example_pheno,control_lab="baseline",pathways=pathways)
    expect_that(length(output),equals(6))  

})    
    
   

context("correct output for compute_gene function")


data(example_data)
data(example_pheno)

control_lab <- "baseline"
control_samples <- example_pheno[example_pheno$Class == control_lab,"Sample"] 

class_lab <- "Asymptomatic"
class_samples <- example_pheno[example_pheno$Class == class_lab,"Sample"] 

class2_lab <- "Symptomatic"
class2_samples <- example_pheno[example_pheno$Class == class2_lab,"Sample"] 

zscore <- compute_zscore(example_data, control_samples)
zscore_binary <- zscore[,2:ncol(zscore)]
zscore_binary[zscore_binary >= 2] <- 1
zscore_binary <- cbind(zscore[,1],zscore_binary)

gmdp_freq_results <- compute_gene_score(zscore, example_pheno, control_lab,"gene_freq")
gmdp_results <- compute_gene_score(zscore, example_pheno, control_lab)


test_that("check that gene score is the mean z-score value for that class",{
    
 expect_equal(as.numeric(gmdp_results[,"baseline"]),
              as.numeric(rowMeans(zscore[,as.character(control_samples)])))
    
 expect_equal(gmdp_results[,class_lab],
              as.numeric(rowMeans(zscore[,as.character(class_samples)])))
 
 expect_equal(gmdp_results[,class2_lab],
              as.numeric(rowMeans(zscore[,as.character(class2_samples)])))
 
})

test_that("check that gene frequency score is the frequency that gene is perturbed in each class",{
    
    expect_equal(as.numeric(gmdp_freq_results[,"baseline"]),
                 as.numeric(rowMeans(zscore_binary[,as.character(control_samples)])))
    
    expect_equal(gmdp_freq_results[,class_lab],
                 as.numeric(rowMeans(zscore_binary[,as.character(class_samples)])))
    
    expect_equal(gmdp_freq_results[,class2_lab],
                 as.numeric(rowMeans(zscore_binary[,as.character(class2_samples)])))
    
    
})

#' Expression data example
#'
#' Author expression data for GEO dataset GSE17156 of transcriptome blood samples from patients that were inoculated with the RSV virus that 
#' has been altered by collapsing for HGNC gene symbols.
#'
#' @format A data frame with 13838 rows and 40 variables:
#' @description 
#' \describe{
#'   \item{rownames}{HGNC gene names}
#'   \item{colnames}{sample expression data}
#'   ...
#' }
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE17156}
"example_data"

#' Phenotypic data example
#'
#' Subset of the annotation data for GEO dataset GSE17156, using only patients that have been inoculated with the RSV virus
#'
#' @format A data frame with 40 rows and 2 variables:
#' \describe{
#'   \item{Sample}{GSM identified}
#'   \item{Class}{Symtpomatic state}
#'   ...
#' }
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE17156}
"example_pheno"


#' Sample score results
#'
#' Resultant sample scores when the mdp is applied to example_data and example_pheno
#'
#' @format A data frame with 40 rows and 3 variables:
#' \describe{
#'   \item{Sample}{GSM identified}
#'   \item{Score}{Sample score}
#'   \item{Class}{Symtpomatic state}
#'   ...
#' }
#'
"sample_data"

%title: mdp - Sample Presentation
%author: visit1985
%date: 2016-02-07

-> mdp <-
=========

-> A command-line based markdown presentation tool. <-

_Basic controls:_

next slide      *Enter*, *Space*, *Page Down*, *j*, *l*,
                *Down Arrow*, *Right Arrow*

previous slide  *Backspace*, *Page Up*, *h*, *k*,
                *Up Arrow*, *Left Arrow*

quit            *q*
reload          *r*
slide N         *1..9*
first slide     *Home*, *g*
last slide      *End*, *G*

-------------------------------------------------

-> # Supported markdown formatting <-

The input file is split into multiple slides by
horizontal rules (hr). A hr consisting of at
least 3 *\** or *-*. It can also contain spaces but
no other characters.

Each of these represents the start of a new slide.

\* \* \*
\---
\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*
\- - -

-------------------------------------------------

-> # Supported markdown formatting <-

First-level headers can be prefixed by single *#*
or underlined by *===*.

\# first-level

becomes

# first-level

-------------------------------------------------

-> # Supported markdown formatting <-

Second-level headers can be prefixed by *##* or
underlined by *---*.

second-level
\------------

becomes

second-level
------------


-------------------------------------------------

-> # Supported markdown formatting's <-

Inline codes are surrounded with backticks.

C program starts with \`main()\`.

becomes

C program starts with `main()`.

-------------------------------------------------

-> # Supported markdown formatting <-

Code blocks are automatically detected by 4 spaces
at the beginning of a line.

Tabs are automatically expanded to 4 spaces while
parsing the input.

\    int main(int argc, char \*argv[]) {
\        printf("%s\\n", "Hello world!");
\    }

becomes

    int main(int argc, char *argv[]) {
        printf("%s\n", "Hello world!");
    }

-------------------------------------------------

-> # Supported markdown formatting <-

You can also use [pandoc](http://pandoc.org/demo/example9/pandocs-markdown.html)'s fenced code block
extension. Use at least three ~ chars to open and
at least as many or more ~ for closing.

\~~~ {.numberLines}
\int main(int argc, char \*argv[]) {
\    printf("%s\\n", "Hello world!");
\}
\~~~~~~~~~~~~~~~~~~

becomes

~~~ {.numberLines}
int main(int argc, char \*argv[]) {
    printf("%s\\n", "Hello world!");
}
~~~~~~~~~~~~~~~~~~

Pandoc attributes (like ".numberlines" etc.)
will be ignored

-------------------------------------------------

-> # Supported markdown formatting <-

Quotes are auto-detected by preceding *>*.

Multiple *>* are interpreted as nested quotes.

\> quote
\>> nested quote 1
\> > nested quote 2

becomes

> quote
>> nested quote 1
> > nested quote 2

-------------------------------------------------

-> # Supported markdown formatting <-

Inline highlighting is supported as followed:

\- *\** colors text as red
\- *\_* underlines text

\_some\_ \*highlighted\* \_\*text\*\_

becomes

_some_ *highlighted* _*text*_

-------------------------------------------------

-> # Supported markdown formatting <-

Backslashes force special markdown characters
like *\**, *\_*, *#* and *>* to be printed as
normal characters.

\\\*special\\\*

becomes

\*special\*

-------------------------------------------------

-> # Supported markdown formatting <-

Leading *\** or *-* indicate lists.

list
\* major
\    - minor
\        - \*important\*
\          detail
\    - minor

becomes

list
* major
    - minor
        - *important*
          detail
    - minor

-------------------------------------------------

-> # Supported markdown formatting <-

A single *\<br\>* or *^* in a line indicates mdp
to stop the output on that position.

This can be used to show bullet points
line by line.

*\<br\>* is also not displayed in HTML converted
output.

Agenda
<br>
* major
<br>
    * minor
<br>
* major
  ^
    * minor
      ^
        * detail

-------------------------------------------------

-> # Supported markdown formatting <-

Leading *->* indicates centering.

\-> # test <-
\-> ## test <-
\-> test
\-> \_\*test\*\_ <-

becomes

-> # test <-
-> ## test <-
-> test
-> _*test*_ <-

-------------------------------------------------

-> # Supported markdown formatting <-

URL in pandoc style are supported:

\[Google](http://www.google.com/)

becomes

[Google](http://www.google.com/)

-------------------------------------------------

-> ## More information about markdown <-

can be found in the [markdown documentation](http://daringfireball.net/projects/markdown/).

-------------------------------------------------

-> # Support for UTF-8 special characters <-

Here are some examples.

ae = ä, oe = ö, ue = ü, ss = ß
upsilon = Ʊ, phi = ɸ

▛▀▀▀▀▀▀▀▀▀▜
▌rectangle▐
▙▄▄▄▄▄▄▄▄▄▟


-------------------------------------------------

-> # Suspend your presentation for hands-on examples <-

Use *Ctrl + z* to suspend the presentation.

Use *fg* to resume it.

-------------------------------------------------

-> # Convert your presentation to PDF <-

To publish your presentation later on, you may
want to convert it to PDF.

This can be achieved by two additional tools:

\- *markdown* to convert to HTML
\- *wkhtmltopdf* to convert from HTML to PDF

After installing them, you can simply type:

    $ markdown sample.md | wkhtmltopdf - sample.pdf

-------------------------------------------------

-> ## Last words <-

I hope you like *mdp*.

If you observe strange behavior, feel free to
open an issue on [GitHub](https://github.com/visit1985/mdp).

---
title: "Running the mdp package"
author:
-name: Melissa Lever
date: "`r Sys.Date()`"
output:
  html_document:
    toc: yes
  pdf_document:
    toc: yes
  prettydoc::html_pretty:
    highlight: github
    theme: lumen
    toc: yes
vignette: >
  %\VignetteIndexEntry{Running the mdp package}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

## About

The Molecular Degree of Perturbation allows you to quantify the heterogeneity of transcriptome data samples. The `mdp` takes data containing at least two classes (control and test) and assigns a score to all samples based on how perturbed they are compared to the controls. Gene perturbation scores are calculated for each gene within each class. The algorithm is based on the Molecular Distance to Health which was first implemented in Pankla et al. 2009. 
It expands on this algorithm by adding the options to calculate the z-score using the modified z-score (using median absolute deviation), change the z-score zeroing threshold, and look at genes that are most perturbed in the test versus control classes.

## Basic usage

Load expression and pheno data and run:

```{r}
library(mdp)
data(example_data) # expression data has gene names in the rows
data(example_pheno) # pheno data needs a Sample and Class column
mdp.results <- mdp(data=example_data, pdata=example_pheno, control_lab = "baseline")
```



### Sample scores
The sample scores can be accessed from the `sample_scores` element of the mdp results.
```{r}
sample_scores_list <- mdp.results$sample_scores
# select sample scores calculated using the perturbed genes
sample_scores <- sample_scores_list[["perturbedgenes"]]
head(sample_scores)
sample_plot(sample_scores,control_lab = "baseline", title="perturbed")
```

### Z-score 
The `mdp` works by calulating the z-score relative to the control samples, taking the absolute value of this matrix and setting all vlaues below a threshold (2 as a default) to 0. Expression values that are not 0 are *perturbed*. You can access this thresholded z-score matrix by,
```{r}
zscore <- mdp.results$zscore
```


### Gene scores
For each gene in each class, a gene score is calculated, which is the average thresholded z-score value for that gene. A gene frequency is also calculated, which is the frequency that the gene is perturbed in a class.
```{r}
gene_scores <- mdp.results$gene_scores
gene_freq <- mdp.results$gene_freq
head(gene_scores)
```


### Perturbed genes
The `mdp` ranks genes according to the difference between their gene score in the test versus the control samples. The `fraction_genes` option for the `mdp` function allows you to control what top fraction of these ranked genes will count as the `perturbed_genes`. You can obtain a list of the perturbed genes from the mdp results,
```{r}
perturbed_genes <- mdp.results$perturbed_genes
```

## Further usage

### Adding pathways
Sample scores can also be calculated using genes that are within certain genesets. The `mdp` will accept genesets that are in the form of a list (see example below). You can read in a .gmt file of genesets using the `fgsea::gmtPathways` function from the `fgsea` package.


```{r results='hide',fig.show = 'hide'}
file_address <- system.file("extdata", "ReactomePathways.gmt", package = "mdp")
pathways <- fgsea::gmtPathways(file_address)
mdp.results <- mdp(data=example_data, pdata=example_pheno, control_lab = "baseline",pathways=pathways)
```

For each pathway, the signal-to-noise ratio of the test versus control sample scores will be calculated. You can access these results in the `pathways` element of the `mdp` results.
```{r}
head(mdp.results$pathways)
sample_scores <- mdp.results$sample_scores[["Interferon alpha/beta signaling"]]
sample_plot(sample_scores,control_lab = "baseline", title="Interferon a/b")

```

### Z-score calculation options

As a default, the `mdp` z-score normalises the expression data using the median as the averaging statistic. The standard deviation is estimated using the median absolute deviation `mad` function from the `Stats` package. If you would like to use the mean instead, select "mean". 
```{r results='hide',fig.show = 'hide'}
mdp.results <- mdp(data=example_data, pdata=example_pheno, control_lab = "baseline", measure = "mean")
```

You can calculate the thresholded z-score using the `compute_zscore` function. A vector of control sample names must be provided.
```{r}
control_samples <- example_pheno[example_pheno$Class == "baseline","Sample"] 
zscore <- compute_zscore(data = example_data,control_samples = control_samples,measure = "mean",std = 2)
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mdp.R
\name{compute_perturbed_genes}
\alias{compute_perturbed_genes}
\title{Compute perturbed genes
Find the top fraction of genes that are more perturbed 
in test versus controls}
\usage{
compute_perturbed_genes(gmdp_results, control_lab, fraction_genes)
}
\arguments{
\item{gmdp_results}{results table of gene scores}

\item{control_lab}{label specificying control class}

\item{fraction_genes}{fraction of top perturbed genes that 
will make the set of perturbed genes}
}
\value{
vector of perturbed genes
}
\description{
Compute perturbed genes
Find the top fraction of genes that are more perturbed 
in test versus controls
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{example_pheno}
\alias{example_pheno}
\title{Phenotypic data example}
\format{A data frame with 40 rows and 2 variables:
\describe{
  \item{Sample}{GSM identified}
  \item{Class}{Symtpomatic state}
  ...
}}
\source{
\url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE17156}
}
\usage{
example_pheno
}
\description{
Subset of the annotation data for GEO dataset GSE17156, using only patients that have been inoculated with the RSV virus
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mdp.R
\name{pathway_summary}
\alias{pathway_summary}
\title{print pathways
generates a summary plot for pathways and sample score plot of best gene set}
\usage{
pathway_summary(sample_results, path, file_name, control_samples,
  control_lab)
}
\arguments{
\item{sample_results}{list of sample scores for each geneset}

\item{path}{directory to save images}

\item{file_name}{name of saved imaged}

\item{control_samples}{list of control sample names}

\item{control_lab}{label that specifies control class}
}
\value{
data frame of signal to noise ratio of control vc test sample scores 
for each pathway
}
\description{
print pathways
generates a summary plot for pathways and sample score plot of best gene set
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{example_data}
\alias{example_data}
\title{Expression data example}
\format{A data frame with 13838 rows and 40 variables:}
\source{
\url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE17156}
}
\usage{
example_data
}
\description{
\describe{
  \item{rownames}{HGNC gene names}
  \item{colnames}{sample expression data}
  ...
}
}
\details{
Author expression data for GEO dataset GSE17156 of transcriptome blood samples from patients that were inoculated with the RSV virus that 
has been altered by collapsing for HGNC gene symbols.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{sample_data}
\alias{sample_data}
\title{Sample score results}
\format{A data frame with 40 rows and 3 variables:
\describe{
  \item{Sample}{GSM identified}
  \item{Score}{Sample score}
  \item{Class}{Symtpomatic state}
  ...
}}
\usage{
sample_data
}
\description{
Resultant sample scores when the mdp is applied to example_data and example_pheno
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mdp.R
\name{compute_zscore}
\alias{compute_zscore}
\title{Computes the thresholded Z score
Plots the Z score using control samples to compute the average and standard 
deviation}
\usage{
compute_zscore(data, control_samples, measure = c("mean", "median"),
  std = 2)
}
\arguments{
\item{data}{Gene expression data with gene symbols in rows, sample names 
in columns}

\item{control_samples}{Character vector specifying the control sample names}

\item{measure}{Either 'mean' or 'median'. 'mean' uses mean and standard 
deviation. 'median' uses the median and the median absolute deviation to 
estimate the standard devation (modified z-score).}

\item{std}{Set as default to 2. This controls the standard deviation threshold 
for the Z-score calculation. #' Normalised expression values less than 'std' 
will be set to 0.}
}
\value{
zscore data frame
}
\description{
Computes the thresholded Z score
Plots the Z score using control samples to compute the average and standard 
deviation
}
\examples{
control_samples <- example_pheno$Sample[example_pheno$Class == 'baseline']
compute_zscore(example_data, control_samples,'median',2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mdp.R
\name{mdp}
\alias{mdp}
\title{Molecular Degree of Perturbation}
\usage{
mdp(data, pdata, control_lab, directory = "", pathways, print = TRUE,
  measure = c("mean", "median"), std = 2, fraction_genes = 0.25,
  save_tables = TRUE, file_name = "")
}
\arguments{
\item{data}{\code{data frame} of gene expression data with the gene symbols 
in the row names}

\item{pdata}{\code{data frame} of phenodata with a column headed Class and the 
other headed Sample.}

\item{control_lab}{character \code{vector} specifying the control class}

\item{directory}{(optional) character string of output directory}

\item{pathways}{(optional) \code{list} whose names are pathways and elements are 
genes in the pathway. see details section for more information}

\item{print}{set as default to TRUE for pdfs of the sample scores 
to be saved}

\item{measure}{'medan' as default, can change to 'median'.
\code{mean} will select for z-score and \code{median} will select for modified
z-score. (see details)}

\item{std}{\code{numeric} set as default to 2, this governs the thresholding of 
expression data. z-scored expression values with absolute value less than 'std' 
will be set to 0.}

\item{fraction_genes}{\code{numeric} fraction of genes that will contribute to the top perturbed genes. Set as default to 0.25}

\item{save_tables}{Set as default to TRUE. Tables of zscore and gene and 
sample scores will be saved.}

\item{file_name}{(optional) character string that will be added to the saved file names}
}
\value{
A list: zscore, gene_scores, gene_freq, sample_scores, perturbed_genes
\itemize{
\item Z-score - z-score is calculated using the control samples to compute
the average and the standard deviation. The absolute value of this
matrix is taken and values less than the std are set to zero.
This z-score data frame is used to compute the gene and sample scores.
\item Gene scores - mean z-score value for each gene in each class
\item Gene frequency - frequency with which a gene has a non zero z-score 
value in each class
\item Sample scores - list containing sample scores for different genesets.
Sample scores are the sum of the z-scored gene values for each sample,
averaged for the number of genes in that geneset.
\item Perturbed genes - vector of the top fraction of genes that have
higher gene scores in the test classes compared to the control.
\item Pathways - if genesets are provided, they are ranked according to the 
signal-to-noise #' ratio of test sample scores versus control sample scores 
calculated using that geneset.
}
}
\description{
Based on the Molecular Distance to Health, this function calculates scores 
to each sample based on their perturbation from healthy
}
\section{Loading pathways}{

a \code{list} of pathways can be loaded from a .gmt file using the
\code{fgsea} function using \code{fgsea::gmtPathways('gmt.file.location')}
}

\section{Selecting mean or median}{

if \code{median} is selected, the z-score will be calculated using the
median, and the standard deviation will be estimated using the median
 absolute deviation, utilising the \code{mad} function.
}

\examples{
# basic run
mdp(example_data,example_pheno,'baseline')
# run with pathways
pathway_file <- system.file('extdata', 'ReactomePathways.gmt', 
package = 'mdp')
mypathway <- fgsea::gmtPathways(pathway_file) # load a gmt file
mdp(data=example_data,pdata=example_pheno,control_lab='baseline',
pathways=mypathway)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mdp.R
\name{compute_sample_scores}
\alias{compute_sample_scores}
\title{Compute sample scores for each pathway}
\usage{
compute_sample_scores(zscore, perturbed_genes, control_samples,
  test_samples, pathways, pdata)
}
\arguments{
\item{zscore}{zscore data frame}

\item{perturbed_genes}{list of pertured genes}

\item{control_samples}{vector of control sample names}

\item{test_samples}{vector of test sample names}

\item{pathways}{list of pathways}

\item{pdata}{phenotypic data with Sample and Class columns}
}
\value{
data frame of sample scores
}
\description{
Compute sample scores for each pathway
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mdp.R
\name{compute_gene_score}
\alias{compute_gene_score}
\title{Compute gene score
Computes gene scores for each gene within each class and perturbation freq}
\usage{
compute_gene_score(zscore, pdata, control_lab,
  score_type = c("gene_score", "gene_freq"))
}
\arguments{
\item{zscore}{zscore data frame}

\item{pdata}{phenotypic data with Class and Sample columns}

\item{control_lab}{character specifying control class}

\item{score_type}{set to 'gene_score' or 'gene_freq' to compute gene scores 
or frequencies}
}
\value{
data frame of gene scores or gene frequencies
}
\description{
Compute gene score
Computes gene scores for each gene within each class and perturbation freq
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mdp.R
\name{sample_plot}
\alias{sample_plot}
\title{Plot sample scores
Plots the sample scores data.frame for a given geneset. 
Data frame must have Score, Sample and Class columns}
\usage{
sample_plot(sample_data, filename = "", directory = "", title = "",
  print = TRUE, display = TRUE, control_lab)
}
\arguments{
\item{sample_data}{\code{data frame} of sample score information for a geneset. 
Must have columns 'Sample', 'Score' and 'Class'}

\item{filename}{(optional) character string that will be added to the saved pdf filename}

\item{directory}{(optional) character string of directory to save file}

\item{title}{(optional) character string of title name for graph}

\item{print}{(default TRUE) Save as a pdf file}

\item{display}{(default TRUE) Display plot}

\item{control_lab}{(optional) character string Specifying control_lab will set the control 
class as light blue as a default}
}
\value{
generates a plot of the sample scores
}
\description{
Plot sample scores
Plots the sample scores data.frame for a given geneset. 
Data frame must have Score, Sample and Class columns
}
\examples{
sample_plot(sample_data = sample_data, control_lab = 'baseline')
}
